// hlavickove subory *******************************************************
// systemove funkcie
#include <stdio.h>
// GL a GLU kniznica
#include <GL/gl.h>
#include <GL/glu.h>
// funkcie SDL kniznice
#include <SDL/SDL.h>

// .h subor
#include "mOGL.h"

// konstruktor *************************************************************
mOGL::mOGL()
{
 t_a=0; t_b=0; // pomocne premenne

 StartInfoPos=10.0f; // pozicia vypisu 1. textu pocas startu aplikacie

 lighting_onoff=1;  // osvetlenie
 normals_onoff=0;   // normaly
 fog_onoff=0;       // hmla
 help_onoff=0;      // napoveda
 pause_motion=0;    // casovo zavisly pohyb
 scene_draw_type=0; // standardny pohlad na scenu
}

// destruktor **************************************************************
mOGL::~mOGL()
{

}

// vypis info pocas startu aplikacie ***************************************
void mOGL::PrintStartInfo(char *infotext)
{
 ogl_Text.OpenDrawString();
 ogl_Text.DrawString(10.0f,StartInfoPos,infotext);
 ogl_Text.CloseDrawString();

 // vymena zobrazovacich zasobnikov, zobrazenie sceny
 SDL_GL_SwapBuffers();

 // dalsi text bude vypisany na novu poziciu
 StartInfoPos+=20.0f;
 // pauza aby bol text aspon chvilku viditelny
 SDL_Delay(300);
}

// inicializacia OpenGL - nastavenie parametrov pre tvorbu OpenGL sceny ****
bool mOGL::gl_initialize(void)
{
 // nastavenie 8-mich vseobecnych materialov
 for (t_a=0;t_a<8;t_a++) {
  ogl_Material[t_a].amb[0]=1.0f; ogl_Material[t_a].amb[1]=1.0f;
  ogl_Material[t_a].amb[2]=1.0f; ogl_Material[t_a].amb[3]=1.0f;
  ogl_Material[t_a].dif[0]=0.6f; ogl_Material[t_a].dif[1]=0.6f;
  ogl_Material[t_a].dif[2]=0.6f; ogl_Material[t_a].dif[3]=1.0f;
  ogl_Material[t_a].spe[0]=1.0f; ogl_Material[t_a].spe[1]=1.0f;
  ogl_Material[t_a].spe[2]=1.0f; ogl_Material[t_a].spe[3]=1.0f;
  ogl_Material[t_a].amb_dif[0]=0.25f; ogl_Material[t_a].amb_dif[1]=0.25f;
  ogl_Material[t_a].amb_dif[2]=0.25f; ogl_Material[t_a].amb_dif[3]=1.0f;
  ogl_Material[t_a].emi[0]=0.0f; ogl_Material[t_a].emi[1]=0.0f;
  ogl_Material[t_a].emi[2]=0.0f; ogl_Material[t_a].emi[3]=1.0f;
  ogl_Material[t_a].shi=0.0f;
  ogl_Material[t_a].transp=0.0f;
  ogl_Material[t_a].sillum[0]=0.0f; ogl_Material[t_a].sillum[1]=0.0f;
  ogl_Material[t_a].sillum[2]=0.0f; ogl_Material[t_a].sillum[3]=1.0f;
 }
 // nastavenie 8-mich vseobecnych svetiel
 for (t_a=0;t_a<8;t_a++) {
  ogl_Light[t_a].amb[0]=0.25f; ogl_Light[t_a].amb[1]=0.25f;
  ogl_Light[t_a].amb[2]=0.25f; ogl_Light[t_a].amb[3]=1.0f;
  ogl_Light[t_a].dif[0]=0.5f; ogl_Light[t_a].dif[1]=0.5f;
  ogl_Light[t_a].dif[2]=0.5f; ogl_Light[t_a].dif[3]=1.0f;
  ogl_Light[t_a].spe[0]=0.75f; ogl_Light[t_a].spe[1]=0.75f;
  ogl_Light[t_a].spe[2]=0.75f; ogl_Light[t_a].spe[3]=1.0f;
  ogl_Light[t_a].pos[0]=0.0f; ogl_Light[t_a].pos[1]=5.0f;
  ogl_Light[t_a].pos[2]=15.0f; ogl_Light[t_a].pos[3]=1.0f;
  // pos[3]=1.0f - vsesmerove svetlo, 0.0f - smerove svetlo
  ogl_Light[t_a].spot[0]=0.0f;
  ogl_Light[t_a].spot[1]=0.0f;
  ogl_Light[t_a].spot[2]=-1.0f;
 }
 // nastavenie farby hmly
 ogl_FogColor[0]=0.0f; ogl_FogColor[1]=0.0f;
 ogl_FogColor[2]=0.0f; ogl_FogColor[3]=1.0f;

 // STAVOVY STROJ STAVOVY STROJ STAVOVY STROJ STAVOVY STROJ STAVOVY STROJ --

 // nastavenie OpenGL zasobnika farieb a hlbky *****************************
 //glClearColor(0.0f,0.0f,0.0f,0.5f); // zasobnik farieb bude vymazavany ciernou farbou
 glClearColor(0.5f,0.5f,0.75f,0.5f); // zasobnik farieb bude vymazavany modrou farbou
 glClearDepth(1.0f);                // zasobnik hlbky bude vymazavany nastavenim na 1.0f

 glDepthFunc(GL_LEQUAL);  // typ porovnavacej funkcie pre urcenie z-vzdialenosti
 glEnable(GL_DEPTH_TEST); // zapnutie testovania hlbky

 glDisable(GL_CULL_FACE); // nastavenie poradia, v ktorom budu definovane vrcholy objektu
 glFrontFace(GL_CCW);     // reprezentovat privratene resp. odvratene plochy,
 glCullFace(GL_BACK);     // CCW - proti smeru hod. ruciciek, CW - v smere hod. ruciciek
 glEnable(GL_CULL_FACE);  // odvratene plochy sa nebudu spracovavat

 // nastavenie parametrov 1. OpenGL svetla
 glLightfv(GL_LIGHT0,GL_AMBIENT,ogl_Light[0].amb);
 glLightfv(GL_LIGHT0,GL_DIFFUSE,ogl_Light[0].dif);
 glLightfv(GL_LIGHT0,GL_SPECULAR,ogl_Light[0].spe);
 glLightfv(GL_LIGHT0,GL_POSITION,ogl_Light[0].pos);
 glEnable(GL_LIGHT0); // ON
 // nastavenie parametrov 2. OpenGL svetla
 glLightfv(GL_LIGHT1,GL_AMBIENT,ogl_Light[1].amb);
 glLightfv(GL_LIGHT1,GL_DIFFUSE,ogl_Light[1].dif);
 glLightfv(GL_LIGHT1,GL_SPECULAR,ogl_Light[1].spe);
 glLightfv(GL_LIGHT1,GL_POSITION,ogl_Light[1].pos);
 //glEnable(GL_LIGHT1); // OFF
 if (lighting_onoff) glEnable(GL_LIGHTING);
 else glDisable(GL_LIGHTING);
 // svetlo sa pocita len pre privratene strany
 glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,0);
 // svetelne vypocty su lokalne
 glLightModelf(GL_LIGHT_MODEL_LOCAL_VIEWER,GL_TRUE);

 // vseobecny material objektov
 glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,ogl_Material[0].amb_dif);
 // farba bude mat vplyv iba na 'diffuse' komponent materialu
 glColorMaterial(GL_FRONT,GL_DIFFUSE);
 // pre Gourandove svetelne vypocty bude pouzity material priradeny objektu,
 // ktory bude ale stale ovplyvneny farbou zadavanou prikazom glColor
 glEnable(GL_COLOR_MATERIAL);
 // zapnutie gourand-jemneho tienovania
 glShadeModel(GL_SMOOTH);
 // trojuholniky budu vyplnene
 glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

 // realnejsie perspektivne vypocty a korekcie
 glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);

 glFogi(GL_FOG_MODE,GL_EXP2);        // typ hmly
 glFogfv(GL_FOG_COLOR,ogl_FogColor); // farba hmly
 glFogf(GL_FOG_DENSITY,0.05f);       // hustota hmly
 glHint(GL_FOG_HINT,GL_DONT_CARE);   //
 glFogf(GL_FOG_START,2000.0f);       // zaciatok viditelnosti hmly
 glFogf(GL_FOG_END,4000.0f);         // vzdialenost maxima hmly
 if (fog_onoff) glEnable(GL_FOG);    // povolenie hmly

 // ZAPNUTIE TEXTUROVANIA
 glEnable(GL_TEXTURE_2D);

 // INICIALIZACIA SCENY INICIALIZACIA SCENY INICIALIZACIA SCENY ------------

 // vymazanie zasobnika farieb a hlbky
 glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

 // inicializacia vypisovania OpenGL textu
 if (ogl_Text.TextInitialize()) {
  fprintf(stderr,"Chyba inicializacie fontu!\n"); return(1);
 }
 // potvrdenie startu OpenGL
 PrintStartInfo("Nastavenie OpenGL stavoveho stroja...");
 PrintStartInfo("OK");

 // zameriavaci kriz
 PrintStartInfo("Nahratie textury zameriavacieho kriza...");
 if (ogl_Texture.LoadCrosshairTexture("data/gfx/crosshair0.bmp")) {
  fprintf(stderr,"Chyba nahratia textury zameriavacieho kriza!\n"); return(1);
 }
 PrintStartInfo("OK");

 // skybox
 PrintStartInfo("Nahratie textur skyboxu...");
 if (ogl_Texture.obj_skybox_init("data/skybox/sky1",".tga")) {
  fprintf(stderr,"Chyba nahratia textur skyboxu!\n"); return(1);
 }
 PrintStartInfo("OK");

 // inicializacia vody
 PrintStartInfo("Inicializacia vody...");
 if (ogl_Water.WaterInit(20.0f,20.0f,80,80)) {
  fprintf(stderr,"Chyba inicializacie vody!\n"); return(1);
 }
 PrintStartInfo("OK");

 // koniec pociatocnych nastaveni, zaciatok interakcie pozorovatela
 PrintStartInfo("START");

 // nastavenie farby a velkosti neskor vypisovaneho textu 
 ogl_Text.SetTextColor(1.0f,0.8f,0.0f);
 ogl_Text.SetTextSize(10);
 
 // nastavenie startovacej farby - biela
 glColor4f(1.0f,1.0f,1.0f,1.0f);
 
 return(0);
}

// vykreslenie OpenGL sceny ************************************************
int mOGL::gl_draw(void)
{
 // detekcia kolizie kamery s trojuholnikmi
 // v pripade kolizie sa upravi poloha kamery
 if (ogl_Camera[0].collision_onoff==1) {
  // kolizia nenastala
  ogl_Camera[0].is_collision=0;
 }
 
 // vymazanie zasobnika farieb a hlbky
 glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

 // zresetovanie modelovej matice
 glLoadIdentity();

 // TRANSFORMACIA SCENY PODLA NASTAVENI AKTUALNEJ KAMERY!
 if (scene_draw_type==0) glMultMatrixf(ogl_Camera[0].matrix);
 else {
  glRotatef(45.0f,1.0f,0.0f,0.0f);  // zapnutie specialneho pohladu na scenu
  glRotatef(-30.0f,0.0f,1.0f,0.0f);
 }

 // SKYBOX
 ogl_Texture.obj_skybox_draw();
 
 // TRANSFORMACIA SCENY PODLA NASTAVENI AKTUALNEJ KAMERY!
 if (scene_draw_type==0) glTranslatef(ogl_Camera[0].posx,ogl_Camera[0].posy,ogl_Camera[0].posz);
 else glTranslatef(-7.5f,-10.0f,-15.0f); // v pripade specialneho pohladu na scenu

 // transformacia polohy svetla podla polohy kamery
 ogl_Light[1].pos[0]=-ogl_Camera[0].posx;
 ogl_Light[1].pos[1]=-ogl_Camera[0].posy;
 ogl_Light[1].pos[2]=-ogl_Camera[0].posz;
 // umiestenenie svetla na preddefinovanu poziciu
 glLightfv(GL_LIGHT0,GL_POSITION,ogl_Light[0].pos);
 // umiestenenie svetla podla polohy kamery
 //glLightfv(GL_LIGHT1,GL_POSITION,ogl_Light[1].pos);

 // KAMENE
 // hodenie kamena
 if (ogl_Camera[0].isFire1) { // lave tlacidlo mysi
  ogl_Water.RockThrow(-ogl_Camera[0].posx,-ogl_Camera[0].posy,-ogl_Camera[0].posz,
	                  -ogl_Camera[0].targetx,-ogl_Camera[0].targety,-ogl_Camera[0].targetz);
 }
 // casova zmena stavu kamenov
 ogl_Water.RocksUpdate(ogl_Camera[0].GetCameraTime());
 // vykreslenie kamenov
 ogl_Water.RocksRender();

 // VODA
 // casova zmena stavu vody
 ogl_Water.WaterUpdate(ogl_Camera[0].GetCameraTime());
 // vykreslenie vody
 ogl_Water.WaterRender(0);
 // vykreslenie normal pre hladinu vody
 if (normals_onoff==1) ogl_Water.WaterRenderNormals(0.25f);

 // vykreslenie zameriavacieho kriza
 ogl_Texture.DrawCrosshair(ogl_Camera[0].scr_w,ogl_Camera[0].scr_h);

 if (help_onoff) {
  // vypis textu - help
  ogl_Text.OpenDrawString();

  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-20.0f, "ESC ukoncenie aplikacie");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-60.0f, "MYS                rotacia v danom smere");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-80.0f, "LAVE TLACIDLO MYSI hodenie kamena");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-100.0f,"SIPKY              posun dopredu,dozadu,vlavo,vpravo");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-120.0f,"SHIFT              zrychlenie posunu");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-160.0f,"R     reinicializacia pohladu kamery");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-180.0f,"M     vyplnene trojuholniky/iba hrany trojuholnikov");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-200.0f,"L     zapnutie/vypnutie osvetlenia");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-220.0f,"N     zapnutie/vypnutie zobrazenia normal");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-240.0f,"G     zapnutie/vypnutie hmly");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-260.0f,"F     zmena typu hmly");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-280.0f,"T     zapnutie/vypnutie texturovania");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-300.0f,"H     zapnutie/vypnutie zobrazenia helpu");
  ogl_Text.DrawString(10.0f,ogl_Camera[0].scr_h-320.0f,"SPACE zmena pohladu na scenu");

  ogl_Text.CloseDrawString();
 }
 else {
  // vypis textu - poloha kamery
  ogl_Text.OpenDrawString();

  sprintf(ogl_Text.numberbuf,"x:%6.2f",-ogl_Camera[0].posx);
  ogl_Text.DrawNumber(10.0f,30.0f);
  sprintf(ogl_Text.numberbuf,"y:%6.2f",-ogl_Camera[0].posy);
  ogl_Text.DrawNumber(10.0f,20.0f);
  sprintf(ogl_Text.numberbuf,"z:%6.2f",-ogl_Camera[0].posz);
  ogl_Text.DrawNumber(10.0f,10.0f);

  // vypis textu - pocet obrazkov za sekundu
  sprintf(ogl_Text.numberbuf,"%i fps",(GLuint) ogl_Camera[0].ogl_fps);
  ogl_Text.DrawNumber(10.0f,ogl_Camera[0].scr_h-20.0f);

  ogl_Text.CloseDrawString();
 }

 return(0);
}

// casovo zavisla uprava objektov, resp. sceny *****************************
int mOGL::gl_iddle(void)
{
 if (pause_motion==0) {

 }

 return(0);
}

// zmena sposobu zobrazenia objektov ***************************************
void mOGL::change_PolygonMode(void)
{
 glGetIntegerv(GL_POLYGON_MODE,&ogl_State[0]);
 // INFO: vypis nacitaneho stavu
 //fprintf(stderr,"ogl_State=%d\n",ogl_State[0]);

 if (ogl_State[0]==GL_LINE) glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
 else glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);

 SDL_Delay(200);
}

// zap/vyp osvetlenia ******************************************************
void mOGL::change_LightingOnOff(void)
{
 if (glIsEnabled(GL_LIGHTING)) glDisable(GL_LIGHTING);
 else glEnable(GL_LIGHTING);

 SDL_Delay(200);
}

// zap/vyp vykreslovania normal ********************************************
void mOGL::change_NormalsOnOff(void)
{
 if (normals_onoff==0) normals_onoff=1;
 else normals_onoff=0;

 SDL_Delay(200);
}

// zap/vyp hmly ************************************************************
void mOGL::change_FogOnOff(void)
{
 if (glIsEnabled(GL_FOG)) glDisable(GL_FOG);
 else glEnable(GL_FOG);

 SDL_Delay(200);
}

// zmena parametrov hmly ***************************************************
void mOGL::change_FogMode(void)
{
 glGetIntegerv(GL_FOG_MODE,&ogl_State[0]);
 // INFO: vypis nacitaneho stavu
 //fprintf(stderr,"ogl_State=%d\n",ogl_State[0]);

 if (ogl_State[0]==GL_EXP) glFogi(GL_FOG_MODE,GL_EXP2);
 else if (ogl_State[0]==GL_EXP2) glFogi(GL_FOG_MODE,GL_LINEAR);
      else glFogi(GL_FOG_MODE,GL_EXP);

 SDL_Delay(200);
}

// zap/vyp texturovania ****************************************************
void mOGL::change_TexOnOff(void)
{
 if (glIsEnabled(GL_TEXTURE_2D)) glDisable(GL_TEXTURE_2D);
 else glEnable(GL_TEXTURE_2D);

 SDL_Delay(200);
}

// zap/vyp vypisu helpu ****************************************************
void mOGL::change_HelpOnOff(void)
{
 if (help_onoff==0) help_onoff=1;
 else help_onoff=0;
 
 SDL_Delay(200);
}

// zap/vyp casovo zavisleho pohybu objektov ********************************
void mOGL::change_PauseMotion(void)
{
 if (pause_motion==0) pause_motion=1;
 else pause_motion=0;
 
 SDL_Delay(200);
}

// zmena pohladu na scenu **************************************************
void mOGL::change_DrawType(void)
{
 if (scene_draw_type==0) scene_draw_type=1;
 else scene_draw_type=0;
 
 SDL_Delay(200);
}
