#ifndef _MOGL_H_
#define _MOGL_H_

// vlastne triedy
#include "mText.h"
#include "mCamera.h"
#include "mTexture.h"
#include "mWater.h"

typedef struct _material { // struktura OpenGL materialu
 GLfloat amb[4],dif[4],spe[4],amb_dif[4],emi[4];
 GLfloat shi,transp,sillum[4];
};

typedef struct _light {    // struktura OpenGL svetla
 GLfloat amb[4],dif[4],spe[4];
 GLfloat pos[4],spot[3];
};

// trieda premennych a funkcii pre pracu s OpenGL
class mOGL {
public:
 mOGL();          // konstruktor
 virtual ~mOGL(); // destruktor

 mCamera ogl_Camera[8]; // pouzite kamery

 GLint ViewPort[4]; // rozmery okna

 bool gl_initialize(void); // inicializacia OpenGL
 int gl_draw(void);        // vykreslenie OpenGL sceny
 int gl_iddle(void);       // casovo zavisla uprava objektov, resp. sceny

 // zmena stavov OpenGL stavoveho stroja -----------------------------------
 void change_PolygonMode(void);   // zmena sposobu zobrazenia objektov
 void change_LightingOnOff(void); // zap/vyp osvetlenia
 void change_NormalsOnOff(void);  // zap/vyp vykreslovania normal
 void change_FogOnOff(void);      // zap/vyp hmly
 void change_FogMode(void);       // zmena parametrov hmly
 void change_TexOnOff(void);      // zap/vyp texturovania
 void change_HelpOnOff(void);     // zap/vyp vypisu helpu
 void change_PauseMotion(void);   // zap/vyp casovo zavisleho pohybu objektov
 void change_DrawType(void);      // zmena pohladu na scenu
private:
 _material ogl_Material[8]; // pouzite materialy
 _light ogl_Light[8];       // pouzite svetla
 GLfloat ogl_FogColor[4];   // farba hmly

 GLuint t_a,t_b; // pomocne premenne

 GLfloat StartInfoPos;                // pozicia vypisu start info
 void PrintStartInfo(char *infotext); // vypis info pocas startu aplikacie

 GLint ogl_State[2]; // pre zistovanie stavov OpenGL stavoveho stroja

 GLubyte lighting_onoff;  // indikator zap/vyp osvetlenia
 GLubyte normals_onoff;   // indikator zap/vyp vykreslovania normal
 GLubyte fog_onoff;       // indikator zap/vyp hmly
 GLubyte help_onoff;      // indikator zap/vyp vypisu helpu
 GLubyte pause_motion;    // indikator zap/vyp casovo zavisleho pohybu objektov
 GLubyte scene_draw_type; // pohlad na scenu

 char fname[128]; // pre ulozenie retazcov - cesta k suboru

 // pouzite triedy ---------------------------------------------------------
 mText ogl_Text;         // instancia triedy mText - praca s textom
 mTexture ogl_Texture;   // instancia triedy mTexture - praca s texturou
 mWater ogl_Water;       // instancia triedy mWater - praca s vodou
};

#endif
