#ifndef _MTEXTURE_H_
#define _MTEXTURE_H_

#define MAP_TEX_NUM 100

// volitelne parametre textury
enum {
 TEXTURE_TRILINEAR=1<<0,
 TEXTURE_CLAMP=1<<1,
 TEXTURE_MIPMAP=1<<2
};

// trieda premennych a funkcii pre pracu s OpenGL texturami
class mTexture {
public:
 mTexture();          // konstruktor
 virtual ~mTexture(); // destruktor

 GLuint texture_id[100]; // identifikatory nahravanych textur
 GLuint texture_count;   // pocet nahratych textur

 int LoadTexture(GLuint id,char *myfile,GLuint mode); // nahratie textury
 void FreeTexture(GLuint id);                         // zrusenie OpenGL textury

 GLuint crosshair_tex_id;        // identifikator textury zameriavacieho kriza

 int LoadCrosshairTexture(char *myfile); // nahratie textury zameriavacieho kriza
 int DrawCrosshair(GLfloat w,GLfloat h); // vykreslenie zameriavacieho kriza

 int obj_skybox_init(char *mydir,char *myext); // inicializacia skyboxu
 void obj_skybox_draw(void);                   // vykreslenie skyboxu
private:
 GLuint t_a,t_b; // pomocne premenne

 GLuint skybox_tex_id[6]; // identifikatory 6-tich textur skyboxu
 GLuint skybox_DL_id;     // identifikator DisplayListu skyboxu
};

#endif
