#ifndef _MWATER_H
#define _MWATER_H

typedef struct _rock { // struktura objektu-kamen
 float vert[3*12]; // 12 vrcholov
 float s;          // velkost
 float x,y,z;      // poloha
 float a,b,c;      // uhly, pod ktorymi bol kamen hodeny (prvky smeroveho vektora)
 float v;          // rychlost kamena
 float lifeT;      // cas "zivota"
 int dropT;        // kamen dopadol na hladinu vody
};

// trieda premennych a funkcii pre pracu s vodou
class mWater {
public:
 mWater();          // konstruktor
 virtual ~mWater(); // destruktor

 // inicializacia vody
 int WaterInit(float SX,float SZ,int DX,int DZ);
 // reset parametrov vody
 void WaterReset(void);

 // vykreslenie vody, normal
 void WaterRender(int type);
 void WaterRenderNormals(float size);

 // simulacia padu objektu do vody
 void WaterDrop(float DPx,float DPy,float DPz);

 // casovo zavisla zmena stavu hladiny vody
 void WaterUpdate(float chTime);

 // hodenie kamena
 void RockThrow(float Cx,float Cy,float Cz,float Tx,float Ty,float Tz);
 // vyvoj "zivota" hodenych kamenov
 void RocksUpdate(float chTime);
 // vykreslenie kamenov
 void RocksRender(void);
private:
 int i,j,x,z;    // pomocne premenne
 float xx,yy,zz; // pomocne premenne

 m3Dvector *v;  // vrcholy siete, ktora tvori vodu
 m3Dvector *vN; // normaly vrcholov
 float sx,sz;   // x,z-rozmer siete (vody)
 int dx,dz;     // x,z-pocet deleni rozmeru (kvalita vody)
 
 float *vF; // velkost "sily" posobiacej na vrchol
 float *vV; // rychlost vrcholu

 float D; // pre vypocet vzdialenosti

 m3Dvector drop_point; // miesto dopadu objektu-kamena

 float w_freq,w_wavelength,w_muffle; // frekvencia,dlzka vlny, utlm

 float chVfps,chMfps; // pre vypocet zmeny rychlosti vrcholu
 
 // vypocet normal pocas zmeny stavu hladiny vody
 void WaterNormals(void);
 // XZ-vzdialenost dvoch vrcholov siete
 float XZDistance(const m3Dvector VA,const m3Dvector VB);
 // uvolnenie alokovanej pamate
 void WaterDestroy(void);
 
 _rock rock[20]; // 20 kamenov
 int rock_id;    // identifikator kamena
 float g_quad;   // pomocna premenna pre vypocet trajektorie
};

#endif
